# -*- coding: utf-8 -*-
# Copyright 2015, 2016, 2017 Ravshello Authors
# License: Apache License 2.0 (see LICENSE or http://apache.org/licenses/LICENSE-2.0.html)

# All references to program name should use this
prog = 'ravshello'

# Version info
__version__ = '1.36.2'
__date__    = '2019/07/23'
version = "{} v{} last mod {}".format(prog, __version__, __date__)

# Defaults
defaultUserCfgDir = '~/.ravshello'
defaultUserCfgFile = 'config.yaml'
defaultAppExpireTime = 120
defaultAppExtendTime = 60
defaultMaxClientRetries = 3

# Some learner mode rules
maxLearnerPublishedApps = 3
maxLearnerActiveVms = 8
maxLearnerExtendTime = 120

# Learner mode can only create apps from blueprints which have
# one of these strings in their description
learnerBlueprintTag = [
    "#is_learner_blueprint",
    "#learner_bp",
    ]

# Both learner and admin will only be able to publish blueprints that have a
# bmc tag to a bmc region; blueprints lacking a bmc tag will not be publishable
# in bmc regions
bmcBlueprintTag = [
    "#is_bmc_blueprint",
    "#bmc",
    ]

# List of BMC (bare-metal-cloud) regionNames
bmcRegionNames = [
    'us-east-5',
    'us-southwest-1',
    'eu-central-3',
    'ca-east-2',
    'eu-west-5',
    ]

# This will hold the options namespace generated by argparse
opts = None

# This will hold the "local" username (nickname)
user = None

# This holds the string that builds app name prefix w/nickname (see config.yaml)
appnameNickPrefix = 'k:'

# This will hold the default app cost bucket (see config.yaml)
appCostBucket = None

# This will hold the RavelloClient object
rClient = None

# This will hold the RavelloCache object
rCache = None

# This will hold the options read from config files
cfgFile = {}
